/* This file is automatically generated by Lemon from input grammar
** source file "parser.y". */
/*
** 2000-05-29
**
** The author disclaims copyright to this source code.  In place of
** a legal notice, here is a blessing:
**
**    May you do good and not evil.
**    May you find forgiveness for yourself and forgive others.
**    May you share freely, never taking more than you give.
**
*************************************************************************
** Driver template for the LEMON parser generator.
**
** The "lemon" program processes an LALR(1) input grammar file, then uses
** this template to construct a parser.  The "lemon" program inserts text
** at each "%%" line.  Also, any "P-a-r-s-e" identifer prefix (without the
** interstitial "-" characters) contained in this template is changed into
** the value of the %name directive from the grammar.  Otherwise, the content
** of this template is copied straight through into the generate parser
** source file.
**
** The following is the concatenation of all %include directives from the
** input grammar file:
*/
/************ Begin %include sections from the grammar ************************/
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <assert.h>

#include "parse.h"
#include "util/arr.h"
#include "rmutil/vector.h"
#include "query_node.h"
#include "vector_index.h"
#include "query_param.h"
#include "query_internal.h"
#include "util/strconv.h"

// strndup + lowercase in one pass!
char *strdupcase(const char *s, size_t len) {
  char *ret = rm_strndup(s, len);
  char *dst = ret;
  char *src = dst;
  while (*src) {
      // unescape 
      if (*src == '\\' && (ispunct(*(src+1)) || isspace(*(src+1)))) {
          ++src;
          continue;
      }
      *dst = tolower(*src);
      ++dst;
      ++src;

  }
  *dst = '\0';
  
  return ret;
}

// unescape a string (non null terminated) and return the new length (may be shorter than the original. This manipulates the string itself 
size_t unescapen(char *s, size_t sz) {
  
  char *dst = s;
  char *src = dst;
  char *end = s + sz;
  while (src < end) {
      // unescape 
      if (*src == '\\' && src + 1 < end &&
         (ispunct(*(src+1)) || isspace(*(src+1)))) {
          ++src;
          continue;
      }
      *dst++ = *src++;
  }
 
  return (size_t)(dst - s);
}

#define NODENN_BOTH_VALID 0
#define NODENN_BOTH_INVALID -1
#define NODENN_ONE_NULL 1 
// Returns:
// 0 if a && b
// -1 if !a && !b
// 1 if a ^ b (i.e. !(a&&b||!a||!b)). The result is stored in `out` 
static int one_not_null(void *a, void *b, void *out) {
    if (a && b) {
        return NODENN_BOTH_VALID;
    } else if (a == NULL && b == NULL) {
        return NODENN_BOTH_INVALID;
    } if (a) {
        *(void **)out = a;
        return NODENN_ONE_NULL;
    } else {
        *(void **)out = b;
        return NODENN_ONE_NULL;
    }
}

void setup_trace(QueryParseCtx *ctx) {
#ifdef PARSER_DEBUG
  void RSQueryParser_Trace(FILE*, char*);
  ctx->trace_log = fopen("/tmp/lemon_query.log", "w");
  RSQueryParser_Trace(ctx->trace_log, "tr: ");
#endif
}

void reportSyntaxError(QueryError *status, QueryToken* tok, const char *msg) {
  if (tok->type == QT_TERM || tok->type == QT_TERM_CASE) {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX,
      "%s at offset %d near %.*s", msg, tok->pos, tok->len, tok->s);
  } else if (tok->type == QT_NUMERIC) {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX,
      "%s at offset %d near %f", msg, tok->pos, tok->numval);
  } else {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX, "%s at offset %d", msg, tok->pos);
  }
}

/**************** End of %include directives **********************************/
/* These constants specify the various numeric values for terminal symbols.
***************** Begin token definitions *************************************/
#ifndef LOWEST
#define LOWEST                          1
#define TILDE                           2
#define TAGLIST                         3
#define QUOTE                           4
#define MODIFIER                        5
#define MINUS                           6
#define NUMBER                          7
#define SIZE                            8
#define STOPWORD                        9
#define STAR                           10
#define TERMLIST                       11
#define TERM                           12
#define PREFIX                         13
#define PERCENT                        14
#define ATTRIBUTE                      15
#define LP                             16
#define RP                             17
#define COLON                          18
#define AND                            19
#define OR                             20
#define ORX                            21
#define TEXTEXPR                       22
#define ARROW                          23
#define TOP_K                          24
#define AS                             25
#define SEMICOLON                      26
#define LB                             27
#define RB                             28
#define LSQB                           29
#define RSQB                           30
#endif
/**************** End token definitions ***************************************/

/* The next sections is a series of control #defines.
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used to store the integer codes
**                       that represent terminal and non-terminal symbols.
**                       "unsigned char" is used if there are fewer than
**                       256 symbols.  Larger types otherwise.
**    YYNOCODE           is a number of type YYCODETYPE that is not used for
**                       any terminal or nonterminal symbol.
**    YYFALLBACK         If defined, this indicates that one or more tokens
**                       (also known as: "terminal symbols") have fall-back
**                       values which should be used if the original symbol
**                       would not parse.  This permits keywords to sometimes
**                       be used as identifiers, for example.
**    YYACTIONTYPE       is the data type used for "action codes" - numbers
**                       that indicate what to do in response to the next
**                       token.
**    RSQueryParser_TOKENTYPE     is the data type used for minor type for terminal
**                       symbols.  Background: A "minor type" is a semantic
**                       value associated with a terminal or non-terminal
**                       symbols.  For example, for an "ID" terminal symbol,
**                       the minor type might be the name of the identifier.
**                       Each non-terminal can have a different minor type.
**                       Terminal symbols all have the same minor type, though.
**                       This macros defines the minor type for terminal 
**                       symbols.
**    YYMINORTYPE        is the data type used for all minor types.
**                       This is typically a union of many types, one of
**                       which is RSQueryParser_TOKENTYPE.  The entry in the union
**                       for terminal symbols is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.  If
**                       zero the stack is dynamically sized using realloc()
**    RSQueryParser_ARG_SDECL     A static variable declaration for the %extra_argument
**    RSQueryParser_ARG_PDECL     A parameter declaration for the %extra_argument
**    RSQueryParser_ARG_PARAM     Code to pass %extra_argument as a subroutine parameter
**    RSQueryParser_ARG_STORE     Code to store %extra_argument into yypParser
**    RSQueryParser_ARG_FETCH     Code to extract %extra_argument from yypParser
**    RSQueryParser_CTX_*         As RSQueryParser_ARG_ except for %extra_context
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYNTOKEN           Number of terminal symbols
**    YY_MAX_SHIFT       Maximum value for shift actions
**    YY_MIN_SHIFTREDUCE Minimum value for shift-reduce actions
**    YY_MAX_SHIFTREDUCE Maximum value for shift-reduce actions
**    YY_ERROR_ACTION    The yy_action[] code for syntax error
**    YY_ACCEPT_ACTION   The yy_action[] code for accept
**    YY_NO_ACTION       The yy_action[] code for no-op
**    YY_MIN_REDUCE      Minimum value for reduce actions
**    YY_MAX_REDUCE      Maximum value for reduce actions
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/************* Begin control #defines *****************************************/
#define YYCODETYPE unsigned char
#define YYNOCODE 56
#define YYACTIONTYPE unsigned short int
#define RSQueryParser_TOKENTYPE QueryToken
typedef union {
  int yyinit;
  RSQueryParser_TOKENTYPE yy0;
  QueryNode * yy35;
  Vector* yy50;
  QueryAttribute yy55;
  SingleVectorQueryParam yy61;
  VectorQueryParams yy74;
  QueryParam * yy78;
  QueryAttribute * yy97;
  RangeNumber yy111;
} YYMINORTYPE;
#ifndef YYSTACKDEPTH
#define YYSTACKDEPTH 100
#endif
#define RSQueryParser_ARG_SDECL  QueryParseCtx *ctx ;
#define RSQueryParser_ARG_PDECL , QueryParseCtx *ctx 
#define RSQueryParser_ARG_PARAM ,ctx 
#define RSQueryParser_ARG_FETCH  QueryParseCtx *ctx =yypParser->ctx ;
#define RSQueryParser_ARG_STORE yypParser->ctx =ctx ;
#define RSQueryParser_CTX_SDECL
#define RSQueryParser_CTX_PDECL
#define RSQueryParser_CTX_PARAM
#define RSQueryParser_CTX_FETCH
#define RSQueryParser_CTX_STORE
#define YYNSTATE             104
#define YYNRULE              90
#define YYNRULE_WITH_ACTION  88
#define YYNTOKEN             31
#define YY_MAX_SHIFT         103
#define YY_MIN_SHIFTREDUCE   165
#define YY_MAX_SHIFTREDUCE   254
#define YY_ERROR_ACTION      255
#define YY_ACCEPT_ACTION     256
#define YY_NO_ACTION         257
#define YY_MIN_REDUCE        258
#define YY_MAX_REDUCE        347
/************* End control #defines *******************************************/
#define YY_NLOOKAHEAD ((int)(sizeof(yy_lookahead)/sizeof(yy_lookahead[0])))

/* Define the yytestcase() macro to be a no-op if is not already defined
** otherwise.
**
** Applications can choose to define yytestcase() in the %include section
** to a macro that can assist in verifying code coverage.  For production
** code the yytestcase() macro should be turned off.  But it is useful
** for testing.
*/
#ifndef yytestcase
# define yytestcase(X)
#endif


/* Next are the tables used to determine what action to take based on the
** current state and lookahead token.  These tables are used to implement
** functions that take a state number and lookahead value and return an
** action integer.  
**
** Suppose the action integer is N.  Then the action is determined as
** follows
**
**   0 <= N <= YY_MAX_SHIFT             Shift N.  That is, push the lookahead
**                                      token onto the stack and goto state N.
**
**   N between YY_MIN_SHIFTREDUCE       Shift to an arbitrary state then
**     and YY_MAX_SHIFTREDUCE           reduce by rule N-YY_MIN_SHIFTREDUCE.
**
**   N == YY_ERROR_ACTION               A syntax error has occurred.
**
**   N == YY_ACCEPT_ACTION              The parser accepts its input.
**
**   N == YY_NO_ACTION                  No such action.  Denotes unused
**                                      slots in the yy_action[] table.
**
**   N between YY_MIN_REDUCE            Reduce by rule N-YY_MIN_REDUCE
**     and YY_MAX_REDUCE
**
** The action table is constructed as a single large table named yy_action[].
** Given state S and lookahead X, the action is computed as either:
**
**    (A)   N = yy_action[ yy_shift_ofst[S] + X ]
**    (B)   N = yy_default[S]
**
** The (A) formula is preferred.  The B formula is used instead if
** yy_lookahead[yy_shift_ofst[S]+X] is not equal to X.
**
** The formulas above are for computing the action when the lookahead is
** a terminal symbol.  If the lookahead is a non-terminal (as occurs after
** a reduce action) then the yy_reduce_ofst[] array is used in place of
** the yy_shift_ofst[] array.
**
** The following are the tables generated in this section:
**
**  yy_action[]        A single table containing all actions.
**  yy_lookahead[]     A table containing the lookahead for each entry in
**                     yy_action.  Used to detect hash collisions.
**  yy_shift_ofst[]    For each state, the offset into yy_action for
**                     shifting terminals.
**  yy_reduce_ofst[]   For each state, the offset into yy_action for
**                     shifting non-terminals after a reduce.
**  yy_default[]       Default action for each state.
**
*********** Begin parsing tables **********************************************/
#define YY_ACTTAB_COUNT (474)
static const YYACTIONTYPE yy_action[] = {
 /*     0 */   308,   49,    5,  345,   35,  209,    6,  244,  245,  194,
 /*    10 */    37,   95,  243,  202,   46,  246,    7,  179,   57,   17,
 /*    20 */     8,   62,    8,   83,  258,   83,    5,  345,   35,  209,
 /*    30 */     6,  244,  245,  194,   84,   64,  243,  202,   46,  246,
 /*    40 */     7,  244,  245,  197,    8,  260,  243,   70,  259,  246,
 /*    50 */     5,   34,   35,  209,    6,  244,  245,  194,  253,  221,
 /*    60 */   243,  202,   46,  246,    1,   18,  345,   35,   79,   19,
 /*    70 */   244,  245,  194,   36,   53,  243,  202,   46,  246,   20,
 /*    80 */   180,   21,   83,   21,  103,   53,  103,   52,   14,    5,
 /*    90 */    63,   35,  209,    6,  244,  245,  194,  253,   54,  243,
 /*   100 */   202,   46,  246,    1,   35,  209,    6,  244,  245,  194,
 /*   110 */   328,   65,  243,  202,   46,  246,    7,  244,  245,   87,
 /*   120 */     8,  103,  243,   83,   51,  246,   18,   47,   35,  102,
 /*   130 */    19,  244,  245,  194,  275,   71,  243,  202,   46,  246,
 /*   140 */    20,  244,  245,  214,   60,  101,  243,  202,  345,  246,
 /*   150 */    43,   33,   42,   39,    5,   38,   35,  209,    6,  244,
 /*   160 */   245,  194,   78,   40,  243,  202,   46,  246,    7,   35,
 /*   170 */    96,   19,  244,  245,  194,   82,   40,  243,  202,   46,
 /*   180 */   246,   20,  241,  242,  289,   21,    3,  240,  103,  285,
 /*   190 */    66,  263,  266,   32,  244,  245,  218,  331,   93,  243,
 /*   200 */   202,   72,  246,  322,  256,   69,   74,   59,   18,   68,
 /*   210 */    35,  186,   19,  244,  245,  194,  275,   75,  243,  202,
 /*   220 */    46,  246,   20,    2,  326,  321,  285,   66,  263,  266,
 /*   230 */    27,  285,   66,  243,  266,   26,  246,   68,   72,  187,
 /*   240 */   332,  288,   76,   74,   59,   67,  244,  245,  194,   59,
 /*   250 */   274,  243,  202,   46,  246,    7,  304,  285,   66,    8,
 /*   260 */   266,   24,   83,  244,  245,  194,  247,  303,  243,  202,
 /*   270 */    46,  246,   20,  248,  327,   59,   21,  209,   11,  103,
 /*   280 */    80,  285,   66,  263,  266,   32,   55,  237,  236,  276,
 /*   290 */   254,  320,  251,   72,   77,  249,   48,    4,   74,   59,
 /*   300 */   285,   66,  263,  266,   29,   55,  237,  236,   41,  232,
 /*   310 */   223,  251,   72,  319,  249,   48,   10,   74,   59,  285,
 /*   320 */    66,  263,  266,   28,   43,  244,  245,   85,   81,  206,
 /*   330 */   243,   72,   45,  246,  207,    2,   74,   59,  285,   66,
 /*   340 */   263,  266,   27,   86,  225,  285,   66,  208,  266,   16,
 /*   350 */    72,   88,   89,  205,   12,   74,   59,  285,   66,  263,
 /*   360 */   266,   32,   91,   59,   92,  204,   94,  203,  335,   72,
 /*   370 */   334,  333,  190,   13,   74,   59,  285,   66,  263,  266,
 /*   380 */    32,  188,   98,   97,  244,  245,  197,   99,   72,  243,
 /*   390 */   100,  189,  246,   74,   59,  285,   66,   61,  266,   25,
 /*   400 */    44,   73,  317,  257,  285,   66,  257,  266,   23,  315,
 /*   410 */   257,  257,  257,   59,  285,   66,  257,  266,   15,  257,
 /*   420 */   285,   66,   59,  266,   30,  257,  257,  285,   66,  257,
 /*   430 */   266,   31,   59,  257,   55,  237,  236,  257,   59,   55,
 /*   440 */   237,  236,  257,  250,   56,   59,  244,  245,   90,   56,
 /*   450 */   257,  243,  244,  245,  246,  312,   50,  243,  257,  257,
 /*   460 */   246,  257,  257,  257,  257,  257,  257,  257,  257,  257,
 /*   470 */   257,  257,  257,   58,
};
static const YYCODETYPE yy_lookahead[] = {
 /*     0 */    34,   35,    2,   47,    4,    5,    6,    7,    8,    9,
 /*    10 */    54,   52,   12,   13,   14,   15,   16,   17,   52,   18,
 /*    20 */    20,   20,   20,   23,    0,   23,    2,   47,    4,    5,
 /*    30 */     6,    7,    8,    9,   54,   24,   12,   13,   14,   15,
 /*    40 */    16,    7,    8,    9,   20,    0,   12,   23,    0,   15,
 /*    50 */     2,   20,    4,    5,    6,    7,    8,    9,   10,   28,
 /*    60 */    12,   13,   14,   15,   16,    2,   47,    4,   23,    6,
 /*    70 */     7,    8,    9,   54,   12,   12,   13,   14,   15,   16,
 /*    80 */    17,   20,   23,   20,   23,   12,   23,   25,   18,    2,
 /*    90 */    20,    4,    5,    6,    7,    8,    9,   10,   25,   12,
 /*   100 */    13,   14,   15,   16,    4,    5,    6,    7,    8,    9,
 /*   110 */    44,   45,   12,   13,   14,   15,   16,    7,    8,    9,
 /*   120 */    20,   23,   12,   23,   14,   15,    2,   35,    4,   15,
 /*   130 */     6,    7,    8,    9,   32,   33,   12,   13,   14,   15,
 /*   140 */    16,    7,    8,    9,   52,   53,   12,   13,   47,   15,
 /*   150 */    27,   27,   29,   29,    2,   54,    4,    5,    6,    7,
 /*   160 */     8,    9,   42,   43,   12,   13,   14,   15,   16,    4,
 /*   170 */    52,    6,    7,    8,    9,   42,   43,   12,   13,   14,
 /*   180 */    15,   16,    7,    8,   52,   20,   31,   12,   23,   34,
 /*   190 */    35,   36,   37,   38,    7,    8,    9,   47,   52,   12,
 /*   200 */    13,   46,   15,   52,   49,   50,   51,   52,    2,   26,
 /*   210 */     4,   28,    6,    7,    8,    9,   32,   33,   12,   13,
 /*   220 */    14,   15,   16,   31,   52,   52,   34,   35,   36,   37,
 /*   230 */    38,   34,   35,   12,   37,   38,   15,   26,   46,   28,
 /*   240 */    47,   52,   50,   51,   52,   55,    7,    8,    9,   52,
 /*   250 */    52,   12,   13,   14,   15,   16,   53,   34,   35,   20,
 /*   260 */    37,   38,   23,    7,    8,    9,    8,   53,   12,   13,
 /*   270 */    14,   15,   16,   15,   44,   52,   20,    5,   31,   23,
 /*   280 */    51,   34,   35,   36,   37,   38,    6,    7,    8,   32,
 /*   290 */    17,    0,   12,   46,   30,   15,   16,   31,   51,   52,
 /*   300 */    34,   35,   36,   37,   38,    6,    7,    8,   29,   15,
 /*   310 */    30,   12,   46,    0,   15,   16,   31,   51,   52,   34,
 /*   320 */    35,   36,   37,   38,   27,    7,    8,    9,   30,   14,
 /*   330 */    12,   46,   14,   15,   14,   31,   51,   52,   34,   35,
 /*   340 */    36,   37,   38,   14,   30,   34,   35,   14,   37,   38,
 /*   350 */    46,   14,   14,   14,   31,   51,   52,   34,   35,   36,
 /*   360 */    37,   38,   14,   52,   14,   14,   14,   14,    4,   46,
 /*   370 */     4,    4,    4,   31,   51,   52,   34,   35,   36,   37,
 /*   380 */    38,    4,    7,    8,    7,    8,    9,   12,   46,   12,
 /*   390 */    15,    4,   15,   51,   52,   34,   35,   18,   37,   38,
 /*   400 */    27,   40,   41,   56,   34,   35,   56,   37,   38,   48,
 /*   410 */    56,   56,   56,   52,   34,   35,   56,   37,   38,   56,
 /*   420 */    34,   35,   52,   37,   38,   56,   56,   34,   35,   56,
 /*   430 */    37,   38,   52,   56,    6,    7,    8,   56,   52,    6,
 /*   440 */     7,    8,   56,   15,   16,   52,    7,    8,    9,   16,
 /*   450 */    56,   12,    7,    8,   15,   34,   35,   12,   56,   56,
 /*   460 */    15,   56,   56,   56,   56,   56,   56,   56,   56,   56,
 /*   470 */    56,   56,   56,   52,   56,   56,   56,   56,   56,   56,
 /*   480 */    56,   56,   56,   56,   31,   31,   31,   31,   31,   31,
 /*   490 */    31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
 /*   500 */    31,   31,   31,   31,   31,
};
#define YY_SHIFT_COUNT    (103)
#define YY_SHIFT_MIN      (0)
#define YY_SHIFT_MAX      (445)
static const unsigned short int yy_shift_ofst[] = {
 /*     0 */    48,   87,    0,   24,  100,  152,  152,  152,  152,  152,
 /*    10 */   239,    2,   59,   59,  124,   63,  165,  206,  206,  206,
 /*    20 */   206,  206,  206,  256,   61,   61,   61,   98,   98,   98,
 /*    30 */    98,   98,   98,  134,  187,  375,  280,  299,  299,  299,
 /*    40 */    62,   11,   11,  114,  114,  110,  318,  377,  428,   34,
 /*    50 */    34,  439,  445,  445,  445,  433,  433,  445,  445,  445,
 /*    60 */   445,  445,  175,  175,  258,   73,  221,  272,  114,   45,
 /*    70 */   123,  183,    1,   31,   70,  211,  273,  291,  264,  279,
 /*    80 */   294,  313,  298,  297,  314,  315,  320,  329,  333,  337,
 /*    90 */   338,  339,  348,  350,  351,  352,  353,  364,  366,  367,
 /*   100 */   368,  387,  379,  373,
};
#define YY_REDUCE_COUNT (68)
#define YY_REDUCE_MIN   (-44)
#define YY_REDUCE_MAX   (421)
static const short yy_reduce_ofst[] = {
 /*     0 */   155,  192,  247,  247,  247,  266,  285,  304,  323,  342,
 /*    10 */   247,  247,  247,  247,  361,  197,  197,  223,  311,  370,
 /*    20 */   380,  386,  393,  197,  197,  197,  197,  197,  197,  197,
 /*    30 */   197,  197,  197,  -34,  421,   92,  -44,  -20,   19,  101,
 /*    40 */    66,  120,  133,  102,  184,  -41,  118,  132,  150,  132,
 /*    50 */   132,  146,  151,  172,  173,  193,  150,  189,  189,  189,
 /*    60 */   189,  198,  203,  214,  190,  230,  132,  229,  257,
};
static const YYACTIONTYPE yy_default[] = {
 /*     0 */   255,  255,  255,  255,  293,  255,  255,  255,  255,  255,
 /*    10 */   291,  261,  264,  265,  255,  255,  294,  255,  255,  255,
 /*    20 */   255,  255,  255,  292,  271,  270,  262,  269,  269,  269,
 /*    30 */   267,  268,  269,  255,  255,  255,  255,  255,  255,  255,
 /*    40 */   324,  255,  255,  278,  278,  255,  255,  255,  255,  309,
 /*    50 */   313,  255,  255,  255,  255,  255,  255,  306,  310,  284,
 /*    60 */   255,  255,  255,  255,  255,  323,  286,  255,  277,  255,
 /*    70 */   255,  255,  255,  305,  255,  255,  255,  255,  255,  255,
 /*    80 */   255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
 /*    90 */   255,  255,  255,  255,  255,  255,  255,  338,  337,  336,
 /*   100 */   339,  255,  255,  255,
};
/********** End of lemon-generated parsing tables *****************************/

/* The next table maps tokens (terminal symbols) into fallback tokens.  
** If a construct like the following:
** 
**      %fallback ID X Y Z.
**
** appears in the grammar, then ID becomes a fallback token for X, Y,
** and Z.  Whenever one of the tokens X, Y, or Z is input to the parser
** but it does not parse, the type of the token is changed to ID and
** the parse is retried before an error is thrown.
**
** This feature can be used, for example, to cause some keywords in a language
** to revert to identifiers if they keyword does not apply in the context where
** it appears.
*/
#ifdef YYFALLBACK
static const YYCODETYPE yyFallback[] = {
};
#endif /* YYFALLBACK */

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
**
** After the "shift" half of a SHIFTREDUCE action, the stateno field
** actually contains the reduce action for the second half of the
** SHIFTREDUCE.
*/
struct yyStackEntry {
  YYACTIONTYPE stateno;  /* The state-number, or reduce action in SHIFTREDUCE */
  YYCODETYPE major;      /* The major token value.  This is the code
                         ** number for the token at this stack level */
  YYMINORTYPE minor;     /* The user-supplied minor token value.  This
                         ** is the value of the token  */
};
typedef struct yyStackEntry yyStackEntry;

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  yyStackEntry *yytos;          /* Pointer to top element of the stack */
#ifdef YYTRACKMAXSTACKDEPTH
  int yyhwm;                    /* High-water mark of the stack */
#endif
#ifndef YYNOERRORRECOVERY
  int yyerrcnt;                 /* Shifts left before out of the error */
#endif
  RSQueryParser_ARG_SDECL                /* A place to hold %extra_argument */
  RSQueryParser_CTX_SDECL                /* A place to hold %extra_context */
#if YYSTACKDEPTH<=0
  int yystksz;                  /* Current side of the stack */
  yyStackEntry *yystack;        /* The parser's stack */
  yyStackEntry yystk0;          /* First stack entry */
#else
  yyStackEntry yystack[YYSTACKDEPTH];  /* The parser's stack */
  yyStackEntry *yystackEnd;            /* Last entry in the stack */
#endif
};
typedef struct yyParser yyParser;

#include <assert.h>
#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;
#endif /* NDEBUG */

#ifndef NDEBUG
/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void RSQueryParser_Trace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}
#endif /* NDEBUG */

#if defined(YYCOVERAGE) || !defined(NDEBUG)
/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static const char *const yyTokenName[] = { 
  /*    0 */ "$",
  /*    1 */ "LOWEST",
  /*    2 */ "TILDE",
  /*    3 */ "TAGLIST",
  /*    4 */ "QUOTE",
  /*    5 */ "MODIFIER",
  /*    6 */ "MINUS",
  /*    7 */ "NUMBER",
  /*    8 */ "SIZE",
  /*    9 */ "STOPWORD",
  /*   10 */ "STAR",
  /*   11 */ "TERMLIST",
  /*   12 */ "TERM",
  /*   13 */ "PREFIX",
  /*   14 */ "PERCENT",
  /*   15 */ "ATTRIBUTE",
  /*   16 */ "LP",
  /*   17 */ "RP",
  /*   18 */ "COLON",
  /*   19 */ "AND",
  /*   20 */ "OR",
  /*   21 */ "ORX",
  /*   22 */ "TEXTEXPR",
  /*   23 */ "ARROW",
  /*   24 */ "TOP_K",
  /*   25 */ "AS",
  /*   26 */ "SEMICOLON",
  /*   27 */ "LB",
  /*   28 */ "RB",
  /*   29 */ "LSQB",
  /*   30 */ "RSQB",
  /*   31 */ "expr",
  /*   32 */ "attribute",
  /*   33 */ "attribute_list",
  /*   34 */ "prefix",
  /*   35 */ "termlist",
  /*   36 */ "union",
  /*   37 */ "text_union",
  /*   38 */ "text_expr",
  /*   39 */ "fuzzy",
  /*   40 */ "tag_list",
  /*   41 */ "geo_filter",
  /*   42 */ "vector_query",
  /*   43 */ "vector_command",
  /*   44 */ "vector_attribute",
  /*   45 */ "vector_attribute_list",
  /*   46 */ "modifierlist",
  /*   47 */ "num",
  /*   48 */ "numeric_range",
  /*   49 */ "query",
  /*   50 */ "star",
  /*   51 */ "modifier",
  /*   52 */ "param_term",
  /*   53 */ "term",
  /*   54 */ "param_any",
  /*   55 */ "param_size",
};
#endif /* defined(YYCOVERAGE) || !defined(NDEBUG) */

#ifndef NDEBUG
/* For tracing reduce actions, the names of all rules are required.
*/
static const char *const yyRuleName[] = {
 /*   0 */ "query ::= expr",
 /*   1 */ "query ::=",
 /*   2 */ "query ::= star",
 /*   3 */ "expr ::= expr expr",
 /*   4 */ "text_expr ::= text_expr text_expr",
 /*   5 */ "expr ::= union",
 /*   6 */ "union ::= expr OR expr",
 /*   7 */ "union ::= union OR expr",
 /*   8 */ "text_expr ::= text_union",
 /*   9 */ "text_union ::= text_expr OR text_expr",
 /*  10 */ "text_union ::= text_union OR text_expr",
 /*  11 */ "expr ::= text_expr",
 /*  12 */ "expr ::= modifier COLON text_expr",
 /*  13 */ "expr ::= modifierlist COLON text_expr",
 /*  14 */ "expr ::= LP expr RP",
 /*  15 */ "text_expr ::= LP text_expr RP",
 /*  16 */ "attribute ::= ATTRIBUTE COLON param_term",
 /*  17 */ "attribute_list ::= attribute",
 /*  18 */ "attribute_list ::= attribute_list SEMICOLON attribute",
 /*  19 */ "attribute_list ::= attribute_list SEMICOLON",
 /*  20 */ "attribute_list ::=",
 /*  21 */ "expr ::= expr ARROW LB attribute_list RB",
 /*  22 */ "text_expr ::= text_expr ARROW LB attribute_list RB",
 /*  23 */ "text_expr ::= QUOTE termlist QUOTE",
 /*  24 */ "text_expr ::= QUOTE term QUOTE",
 /*  25 */ "text_expr ::= QUOTE ATTRIBUTE QUOTE",
 /*  26 */ "text_expr ::= param_term",
 /*  27 */ "text_expr ::= prefix",
 /*  28 */ "text_expr ::= termlist",
 /*  29 */ "text_expr ::= STOPWORD",
 /*  30 */ "termlist ::= param_term param_term",
 /*  31 */ "termlist ::= termlist param_term",
 /*  32 */ "termlist ::= termlist STOPWORD",
 /*  33 */ "expr ::= MINUS expr",
 /*  34 */ "text_expr ::= MINUS text_expr",
 /*  35 */ "expr ::= TILDE expr",
 /*  36 */ "text_expr ::= TILDE text_expr",
 /*  37 */ "prefix ::= PREFIX",
 /*  38 */ "text_expr ::= PERCENT param_term PERCENT",
 /*  39 */ "text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT",
 /*  40 */ "text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT",
 /*  41 */ "text_expr ::= PERCENT STOPWORD PERCENT",
 /*  42 */ "text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT",
 /*  43 */ "text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT",
 /*  44 */ "modifier ::= MODIFIER",
 /*  45 */ "modifierlist ::= modifier OR term",
 /*  46 */ "modifierlist ::= modifierlist OR term",
 /*  47 */ "expr ::= modifier COLON tag_list",
 /*  48 */ "tag_list ::= LB param_term",
 /*  49 */ "tag_list ::= LB STOPWORD",
 /*  50 */ "tag_list ::= LB prefix",
 /*  51 */ "tag_list ::= LB termlist",
 /*  52 */ "tag_list ::= tag_list OR param_term",
 /*  53 */ "tag_list ::= tag_list OR STOPWORD",
 /*  54 */ "tag_list ::= tag_list OR prefix",
 /*  55 */ "tag_list ::= tag_list OR termlist",
 /*  56 */ "tag_list ::= tag_list RB",
 /*  57 */ "expr ::= modifier COLON numeric_range",
 /*  58 */ "numeric_range ::= LSQB param_any param_any RSQB",
 /*  59 */ "expr ::= modifier COLON geo_filter",
 /*  60 */ "geo_filter ::= LSQB param_any param_any param_any param_any RSQB",
 /*  61 */ "query ::= expr ARROW LSQB vector_query RSQB",
 /*  62 */ "query ::= star ARROW LSQB vector_query RSQB",
 /*  63 */ "vector_query ::= vector_command vector_attribute_list AS param_term",
 /*  64 */ "vector_query ::= vector_command AS param_term",
 /*  65 */ "vector_query ::= vector_command vector_attribute_list",
 /*  66 */ "vector_query ::= vector_command",
 /*  67 */ "vector_command ::= TOP_K param_size modifier ATTRIBUTE",
 /*  68 */ "vector_attribute ::= TERM param_term",
 /*  69 */ "vector_attribute_list ::= vector_attribute_list vector_attribute",
 /*  70 */ "vector_attribute_list ::= vector_attribute",
 /*  71 */ "num ::= SIZE",
 /*  72 */ "num ::= NUMBER",
 /*  73 */ "num ::= LP num",
 /*  74 */ "num ::= MINUS num",
 /*  75 */ "term ::= TERM",
 /*  76 */ "term ::= NUMBER",
 /*  77 */ "term ::= SIZE",
 /*  78 */ "param_term ::= TERM",
 /*  79 */ "param_term ::= NUMBER",
 /*  80 */ "param_term ::= SIZE",
 /*  81 */ "param_term ::= ATTRIBUTE",
 /*  82 */ "param_size ::= SIZE",
 /*  83 */ "param_size ::= ATTRIBUTE",
 /*  84 */ "param_any ::= ATTRIBUTE",
 /*  85 */ "param_any ::= LP ATTRIBUTE",
 /*  86 */ "param_any ::= TERM",
 /*  87 */ "param_any ::= num",
 /*  88 */ "star ::= STAR",
 /*  89 */ "star ::= LP star RP",
};
#endif /* NDEBUG */


#if YYSTACKDEPTH<=0
/*
** Try to increase the size of the parser stack.  Return the number
** of errors.  Return 0 on success.
*/
static int yyGrowStack(yyParser *p){
  int newSize;
  int idx;
  yyStackEntry *pNew;

  newSize = p->yystksz*2 + 100;
  idx = p->yytos ? (int)(p->yytos - p->yystack) : 0;
  if( p->yystack==&p->yystk0 ){
    pNew = malloc(newSize*sizeof(pNew[0]));
    if( pNew ) pNew[0] = p->yystk0;
  }else{
    pNew = realloc(p->yystack, newSize*sizeof(pNew[0]));
  }
  if( pNew ){
    p->yystack = pNew;
    p->yytos = &p->yystack[idx];
#ifndef NDEBUG
    if( yyTraceFILE ){
      fprintf(yyTraceFILE,"%sStack grows from %d to %d entries.\n",
              yyTracePrompt, p->yystksz, newSize);
    }
#endif
    p->yystksz = newSize;
  }
  return pNew==0; 
}
#endif

/* Datatype of the argument to the memory allocated passed as the
** second argument to RSQueryParser_Alloc() below.  This can be changed by
** putting an appropriate #define in the %include section of the input
** grammar.
*/
#ifndef YYMALLOCARGTYPE
# define YYMALLOCARGTYPE size_t
#endif

/* Initialize a new parser that has already been allocated.
*/
void RSQueryParser_Init(void *yypRawParser RSQueryParser_CTX_PDECL){
  yyParser *yypParser = (yyParser*)yypRawParser;
  RSQueryParser_CTX_STORE
#ifdef YYTRACKMAXSTACKDEPTH
  yypParser->yyhwm = 0;
#endif
#if YYSTACKDEPTH<=0
  yypParser->yytos = NULL;
  yypParser->yystack = NULL;
  yypParser->yystksz = 0;
  if( yyGrowStack(yypParser) ){
    yypParser->yystack = &yypParser->yystk0;
    yypParser->yystksz = 1;
  }
#endif
#ifndef YYNOERRORRECOVERY
  yypParser->yyerrcnt = -1;
#endif
  yypParser->yytos = yypParser->yystack;
  yypParser->yystack[0].stateno = 0;
  yypParser->yystack[0].major = 0;
#if YYSTACKDEPTH>0
  yypParser->yystackEnd = &yypParser->yystack[YYSTACKDEPTH-1];
#endif
}

#ifndef RSQueryParser__ENGINEALWAYSONSTACK
/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to RSQueryParser_ and RSQueryParser_Free.
*/
void *RSQueryParser_Alloc(void *(*mallocProc)(YYMALLOCARGTYPE) RSQueryParser_CTX_PDECL){
  yyParser *yypParser;
  yypParser = (yyParser*)(*mallocProc)( (YYMALLOCARGTYPE)sizeof(yyParser) );
  if( yypParser ){
    RSQueryParser_CTX_STORE
    RSQueryParser_Init(yypParser RSQueryParser_CTX_PARAM);
  }
  return (void*)yypParser;
}
#endif /* RSQueryParser__ENGINEALWAYSONSTACK */


/* The following function deletes the "minor type" or semantic value
** associated with a symbol.  The symbol can be either a terminal
** or nonterminal. "yymajor" is the symbol code, and "yypminor" is
** a pointer to the value to be deleted.  The code used to do the 
** deletions is derived from the %destructor and/or %token_destructor
** directives of the input grammar.
*/
static void yy_destructor(
  yyParser *yypParser,    /* The parser */
  YYCODETYPE yymajor,     /* Type code for object to destroy */
  YYMINORTYPE *yypminor   /* The object to be destroyed */
){
  RSQueryParser_ARG_FETCH
  RSQueryParser_CTX_FETCH
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are *not* used
    ** inside the C code.
    */
/********* Begin destructor definitions ***************************************/
      /* Default NON-TERMINAL Destructor */
    case 44: /* vector_attribute */
    case 47: /* num */
    case 49: /* query */
    case 50: /* star */
    case 51: /* modifier */
    case 52: /* param_term */
    case 53: /* term */
    case 54: /* param_any */
    case 55: /* param_size */
{
 
}
      break;
    case 31: /* expr */
    case 34: /* prefix */
    case 35: /* termlist */
    case 36: /* union */
    case 37: /* text_union */
    case 38: /* text_expr */
    case 39: /* fuzzy */
    case 40: /* tag_list */
    case 42: /* vector_query */
    case 43: /* vector_command */
{
 QueryNode_Free((yypminor->yy35)); 
}
      break;
    case 32: /* attribute */
{
 rm_free((char*)(yypminor->yy55).value); 
}
      break;
    case 33: /* attribute_list */
{
 array_free_ex((yypminor->yy97), rm_free((char*)((QueryAttribute*)ptr )->value)); 
}
      break;
    case 41: /* geo_filter */
{
 QueryParam_Free((yypminor->yy78)); 
}
      break;
    case 45: /* vector_attribute_list */
{

  array_free((yypminor->yy74).needResolve);
  array_free_ex((yypminor->yy74).params, {
    rm_free((char*)((VecSimRawParam*)ptr)->value);
    rm_free((char*)((VecSimRawParam*)ptr)->name);
  });

}
      break;
    case 46: /* modifierlist */
{
 
    for (size_t i = 0; i < Vector_Size((yypminor->yy50)); i++) {
        char *s;
        Vector_Get((yypminor->yy50), i, &s);
        rm_free(s);
    }
    Vector_Free((yypminor->yy50)); 

}
      break;
    case 48: /* numeric_range */
{

  QueryParam_Free((yypminor->yy78));

}
      break;
/********* End destructor definitions *****************************************/
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
*/
static void yy_pop_parser_stack(yyParser *pParser){
  yyStackEntry *yytos;
  assert( pParser->yytos!=0 );
  assert( pParser->yytos > pParser->yystack );
  yytos = pParser->yytos--;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[yytos->major]);
  }
#endif
  yy_destructor(pParser, yytos->major, &yytos->minor);
}

/*
** Clear all secondary memory allocations from the parser
*/
void RSQueryParser_Finalize(void *p){
  yyParser *pParser = (yyParser*)p;
  while( pParser->yytos>pParser->yystack ) yy_pop_parser_stack(pParser);
#if YYSTACKDEPTH<=0
  if( pParser->yystack!=&pParser->yystk0 ) free(pParser->yystack);
#endif
}

#ifndef RSQueryParser__ENGINEALWAYSONSTACK
/* 
** Deallocate and destroy a parser.  Destructors are called for
** all stack elements before shutting the parser down.
**
** If the YYPARSEFREENEVERNULL macro exists (for example because it
** is defined in a %include section of the input grammar) then it is
** assumed that the input pointer is never NULL.
*/
void RSQueryParser_Free(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
#ifndef YYPARSEFREENEVERNULL
  if( p==0 ) return;
#endif
  RSQueryParser_Finalize(p);
  (*freeProc)(p);
}
#endif /* RSQueryParser__ENGINEALWAYSONSTACK */

/*
** Return the peak depth of the stack for a parser.
*/
#ifdef YYTRACKMAXSTACKDEPTH
int RSQueryParser_StackPeak(void *p){
  yyParser *pParser = (yyParser*)p;
  return pParser->yyhwm;
}
#endif

/* This array of booleans keeps track of the parser statement
** coverage.  The element yycoverage[X][Y] is set when the parser
** is in state X and has a lookahead token Y.  In a well-tested
** systems, every element of this matrix should end up being set.
*/
#if defined(YYCOVERAGE)
static unsigned char yycoverage[YYNSTATE][YYNTOKEN];
#endif

/*
** Write into out a description of every state/lookahead combination that
**
**   (1)  has not been used by the parser, and
**   (2)  is not a syntax error.
**
** Return the number of missed state/lookahead combinations.
*/
#if defined(YYCOVERAGE)
int RSQueryParser_Coverage(FILE *out){
  int stateno, iLookAhead, i;
  int nMissed = 0;
  for(stateno=0; stateno<YYNSTATE; stateno++){
    i = yy_shift_ofst[stateno];
    for(iLookAhead=0; iLookAhead<YYNTOKEN; iLookAhead++){
      if( yy_lookahead[i+iLookAhead]!=iLookAhead ) continue;
      if( yycoverage[stateno][iLookAhead]==0 ) nMissed++;
      if( out ){
        fprintf(out,"State %d lookahead %s %s\n", stateno,
                yyTokenName[iLookAhead],
                yycoverage[stateno][iLookAhead] ? "ok" : "missed");
      }
    }
  }
  return nMissed;
}
#endif

/*
** Find the appropriate action for a parser given the terminal
** look-ahead token iLookAhead.
*/
static YYACTIONTYPE yy_find_shift_action(
  YYCODETYPE iLookAhead,    /* The look-ahead token */
  YYACTIONTYPE stateno      /* Current state number */
){
  int i;

  if( stateno>YY_MAX_SHIFT ) return stateno;
  assert( stateno <= YY_SHIFT_COUNT );
#if defined(YYCOVERAGE)
  yycoverage[stateno][iLookAhead] = 1;
#endif
  do{
    i = yy_shift_ofst[stateno];
    assert( i>=0 );
    assert( i<=YY_ACTTAB_COUNT );
    assert( i+YYNTOKEN<=(int)YY_NLOOKAHEAD );
    assert( iLookAhead!=YYNOCODE );
    assert( iLookAhead < YYNTOKEN );
    i += iLookAhead;
    assert( i<(int)YY_NLOOKAHEAD );
    if( yy_lookahead[i]!=iLookAhead ){
#ifdef YYFALLBACK
      YYCODETYPE iFallback;            /* Fallback token */
      assert( iLookAhead<sizeof(yyFallback)/sizeof(yyFallback[0]) );
      iFallback = yyFallback[iLookAhead];
      if( iFallback!=0 ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE, "%sFALLBACK %s => %s\n",
             yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[iFallback]);
        }
#endif
        assert( yyFallback[iFallback]==0 ); /* Fallback loop must terminate */
        iLookAhead = iFallback;
        continue;
      }
#endif
#ifdef YYWILDCARD
      {
        int j = i - iLookAhead + YYWILDCARD;
        assert( j<(int)(sizeof(yy_lookahead)/sizeof(yy_lookahead[0])) );
        if( yy_lookahead[j]==YYWILDCARD && iLookAhead>0 ){
#ifndef NDEBUG
          if( yyTraceFILE ){
            fprintf(yyTraceFILE, "%sWILDCARD %s => %s\n",
               yyTracePrompt, yyTokenName[iLookAhead],
               yyTokenName[YYWILDCARD]);
          }
#endif /* NDEBUG */
          return yy_action[j];
        }
      }
#endif /* YYWILDCARD */
      return yy_default[stateno];
    }else{
      assert( i>=0 && i<(int)(sizeof(yy_action)/sizeof(yy_action[0])) );
      return yy_action[i];
    }
  }while(1);
}

/*
** Find the appropriate action for a parser given the non-terminal
** look-ahead token iLookAhead.
*/
static YYACTIONTYPE yy_find_reduce_action(
  YYACTIONTYPE stateno,     /* Current state number */
  YYCODETYPE iLookAhead     /* The look-ahead token */
){
  int i;
#ifdef YYERRORSYMBOL
  if( stateno>YY_REDUCE_COUNT ){
    return yy_default[stateno];
  }
#else
  assert( stateno<=YY_REDUCE_COUNT );
#endif
  i = yy_reduce_ofst[stateno];
  assert( iLookAhead!=YYNOCODE );
  i += iLookAhead;
#ifdef YYERRORSYMBOL
  if( i<0 || i>=YY_ACTTAB_COUNT || yy_lookahead[i]!=iLookAhead ){
    return yy_default[stateno];
  }
#else
  assert( i>=0 && i<YY_ACTTAB_COUNT );
  assert( yy_lookahead[i]==iLookAhead );
#endif
  return yy_action[i];
}

/*
** The following routine is called if the stack overflows.
*/
static void yyStackOverflow(yyParser *yypParser){
   RSQueryParser_ARG_FETCH
   RSQueryParser_CTX_FETCH
#ifndef NDEBUG
   if( yyTraceFILE ){
     fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
   }
#endif
   while( yypParser->yytos>yypParser->yystack ) yy_pop_parser_stack(yypParser);
   /* Here code is inserted which will execute if the parser
   ** stack every overflows */
/******** Begin %stack_overflow code ******************************************/
/******** End %stack_overflow code ********************************************/
   RSQueryParser_ARG_STORE /* Suppress warning about unused %extra_argument var */
   RSQueryParser_CTX_STORE
}

/*
** Print tracing information for a SHIFT action
*/
#ifndef NDEBUG
static void yyTraceShift(yyParser *yypParser, int yyNewState, const char *zTag){
  if( yyTraceFILE ){
    if( yyNewState<YYNSTATE ){
      fprintf(yyTraceFILE,"%s%s '%s', go to state %d\n",
         yyTracePrompt, zTag, yyTokenName[yypParser->yytos->major],
         yyNewState);
    }else{
      fprintf(yyTraceFILE,"%s%s '%s', pending reduce %d\n",
         yyTracePrompt, zTag, yyTokenName[yypParser->yytos->major],
         yyNewState - YY_MIN_REDUCE);
    }
  }
}
#else
# define yyTraceShift(X,Y,Z)
#endif

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  YYACTIONTYPE yyNewState,      /* The new state to shift in */
  YYCODETYPE yyMajor,           /* The major token to shift in */
  RSQueryParser_TOKENTYPE yyMinor        /* The minor token to shift in */
){
  yyStackEntry *yytos;
  yypParser->yytos++;
#ifdef YYTRACKMAXSTACKDEPTH
  if( (int)(yypParser->yytos - yypParser->yystack)>yypParser->yyhwm ){
    yypParser->yyhwm++;
    assert( yypParser->yyhwm == (int)(yypParser->yytos - yypParser->yystack) );
  }
#endif
#if YYSTACKDEPTH>0 
  if( yypParser->yytos>yypParser->yystackEnd ){
    yypParser->yytos--;
    yyStackOverflow(yypParser);
    return;
  }
#else
  if( yypParser->yytos>=&yypParser->yystack[yypParser->yystksz] ){
    if( yyGrowStack(yypParser) ){
      yypParser->yytos--;
      yyStackOverflow(yypParser);
      return;
    }
  }
#endif
  if( yyNewState > YY_MAX_SHIFT ){
    yyNewState += YY_MIN_REDUCE - YY_MIN_SHIFTREDUCE;
  }
  yytos = yypParser->yytos;
  yytos->stateno = yyNewState;
  yytos->major = yyMajor;
  yytos->minor.yy0 = yyMinor;
  yyTraceShift(yypParser, yyNewState, "Shift");
}

/* For rule J, yyRuleInfoLhs[J] contains the symbol on the left-hand side
** of that rule */
static const YYCODETYPE yyRuleInfoLhs[] = {
    49,  /* (0) query ::= expr */
    49,  /* (1) query ::= */
    49,  /* (2) query ::= star */
    31,  /* (3) expr ::= expr expr */
    38,  /* (4) text_expr ::= text_expr text_expr */
    31,  /* (5) expr ::= union */
    36,  /* (6) union ::= expr OR expr */
    36,  /* (7) union ::= union OR expr */
    38,  /* (8) text_expr ::= text_union */
    37,  /* (9) text_union ::= text_expr OR text_expr */
    37,  /* (10) text_union ::= text_union OR text_expr */
    31,  /* (11) expr ::= text_expr */
    31,  /* (12) expr ::= modifier COLON text_expr */
    31,  /* (13) expr ::= modifierlist COLON text_expr */
    31,  /* (14) expr ::= LP expr RP */
    38,  /* (15) text_expr ::= LP text_expr RP */
    32,  /* (16) attribute ::= ATTRIBUTE COLON param_term */
    33,  /* (17) attribute_list ::= attribute */
    33,  /* (18) attribute_list ::= attribute_list SEMICOLON attribute */
    33,  /* (19) attribute_list ::= attribute_list SEMICOLON */
    33,  /* (20) attribute_list ::= */
    31,  /* (21) expr ::= expr ARROW LB attribute_list RB */
    38,  /* (22) text_expr ::= text_expr ARROW LB attribute_list RB */
    38,  /* (23) text_expr ::= QUOTE termlist QUOTE */
    38,  /* (24) text_expr ::= QUOTE term QUOTE */
    38,  /* (25) text_expr ::= QUOTE ATTRIBUTE QUOTE */
    38,  /* (26) text_expr ::= param_term */
    38,  /* (27) text_expr ::= prefix */
    38,  /* (28) text_expr ::= termlist */
    38,  /* (29) text_expr ::= STOPWORD */
    35,  /* (30) termlist ::= param_term param_term */
    35,  /* (31) termlist ::= termlist param_term */
    35,  /* (32) termlist ::= termlist STOPWORD */
    31,  /* (33) expr ::= MINUS expr */
    38,  /* (34) text_expr ::= MINUS text_expr */
    31,  /* (35) expr ::= TILDE expr */
    38,  /* (36) text_expr ::= TILDE text_expr */
    34,  /* (37) prefix ::= PREFIX */
    38,  /* (38) text_expr ::= PERCENT param_term PERCENT */
    38,  /* (39) text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
    38,  /* (40) text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
    38,  /* (41) text_expr ::= PERCENT STOPWORD PERCENT */
    38,  /* (42) text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT */
    38,  /* (43) text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT */
    51,  /* (44) modifier ::= MODIFIER */
    46,  /* (45) modifierlist ::= modifier OR term */
    46,  /* (46) modifierlist ::= modifierlist OR term */
    31,  /* (47) expr ::= modifier COLON tag_list */
    40,  /* (48) tag_list ::= LB param_term */
    40,  /* (49) tag_list ::= LB STOPWORD */
    40,  /* (50) tag_list ::= LB prefix */
    40,  /* (51) tag_list ::= LB termlist */
    40,  /* (52) tag_list ::= tag_list OR param_term */
    40,  /* (53) tag_list ::= tag_list OR STOPWORD */
    40,  /* (54) tag_list ::= tag_list OR prefix */
    40,  /* (55) tag_list ::= tag_list OR termlist */
    40,  /* (56) tag_list ::= tag_list RB */
    31,  /* (57) expr ::= modifier COLON numeric_range */
    48,  /* (58) numeric_range ::= LSQB param_any param_any RSQB */
    31,  /* (59) expr ::= modifier COLON geo_filter */
    41,  /* (60) geo_filter ::= LSQB param_any param_any param_any param_any RSQB */
    49,  /* (61) query ::= expr ARROW LSQB vector_query RSQB */
    49,  /* (62) query ::= star ARROW LSQB vector_query RSQB */
    42,  /* (63) vector_query ::= vector_command vector_attribute_list AS param_term */
    42,  /* (64) vector_query ::= vector_command AS param_term */
    42,  /* (65) vector_query ::= vector_command vector_attribute_list */
    42,  /* (66) vector_query ::= vector_command */
    43,  /* (67) vector_command ::= TOP_K param_size modifier ATTRIBUTE */
    44,  /* (68) vector_attribute ::= TERM param_term */
    45,  /* (69) vector_attribute_list ::= vector_attribute_list vector_attribute */
    45,  /* (70) vector_attribute_list ::= vector_attribute */
    47,  /* (71) num ::= SIZE */
    47,  /* (72) num ::= NUMBER */
    47,  /* (73) num ::= LP num */
    47,  /* (74) num ::= MINUS num */
    53,  /* (75) term ::= TERM */
    53,  /* (76) term ::= NUMBER */
    53,  /* (77) term ::= SIZE */
    52,  /* (78) param_term ::= TERM */
    52,  /* (79) param_term ::= NUMBER */
    52,  /* (80) param_term ::= SIZE */
    52,  /* (81) param_term ::= ATTRIBUTE */
    55,  /* (82) param_size ::= SIZE */
    55,  /* (83) param_size ::= ATTRIBUTE */
    54,  /* (84) param_any ::= ATTRIBUTE */
    54,  /* (85) param_any ::= LP ATTRIBUTE */
    54,  /* (86) param_any ::= TERM */
    54,  /* (87) param_any ::= num */
    50,  /* (88) star ::= STAR */
    50,  /* (89) star ::= LP star RP */
};

/* For rule J, yyRuleInfoNRhs[J] contains the negative of the number
** of symbols on the right-hand side of that rule. */
static const signed char yyRuleInfoNRhs[] = {
   -1,  /* (0) query ::= expr */
    0,  /* (1) query ::= */
   -1,  /* (2) query ::= star */
   -2,  /* (3) expr ::= expr expr */
   -2,  /* (4) text_expr ::= text_expr text_expr */
   -1,  /* (5) expr ::= union */
   -3,  /* (6) union ::= expr OR expr */
   -3,  /* (7) union ::= union OR expr */
   -1,  /* (8) text_expr ::= text_union */
   -3,  /* (9) text_union ::= text_expr OR text_expr */
   -3,  /* (10) text_union ::= text_union OR text_expr */
   -1,  /* (11) expr ::= text_expr */
   -3,  /* (12) expr ::= modifier COLON text_expr */
   -3,  /* (13) expr ::= modifierlist COLON text_expr */
   -3,  /* (14) expr ::= LP expr RP */
   -3,  /* (15) text_expr ::= LP text_expr RP */
   -3,  /* (16) attribute ::= ATTRIBUTE COLON param_term */
   -1,  /* (17) attribute_list ::= attribute */
   -3,  /* (18) attribute_list ::= attribute_list SEMICOLON attribute */
   -2,  /* (19) attribute_list ::= attribute_list SEMICOLON */
    0,  /* (20) attribute_list ::= */
   -5,  /* (21) expr ::= expr ARROW LB attribute_list RB */
   -5,  /* (22) text_expr ::= text_expr ARROW LB attribute_list RB */
   -3,  /* (23) text_expr ::= QUOTE termlist QUOTE */
   -3,  /* (24) text_expr ::= QUOTE term QUOTE */
   -3,  /* (25) text_expr ::= QUOTE ATTRIBUTE QUOTE */
   -1,  /* (26) text_expr ::= param_term */
   -1,  /* (27) text_expr ::= prefix */
   -1,  /* (28) text_expr ::= termlist */
   -1,  /* (29) text_expr ::= STOPWORD */
   -2,  /* (30) termlist ::= param_term param_term */
   -2,  /* (31) termlist ::= termlist param_term */
   -2,  /* (32) termlist ::= termlist STOPWORD */
   -2,  /* (33) expr ::= MINUS expr */
   -2,  /* (34) text_expr ::= MINUS text_expr */
   -2,  /* (35) expr ::= TILDE expr */
   -2,  /* (36) text_expr ::= TILDE text_expr */
   -1,  /* (37) prefix ::= PREFIX */
   -3,  /* (38) text_expr ::= PERCENT param_term PERCENT */
   -5,  /* (39) text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
   -7,  /* (40) text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
   -3,  /* (41) text_expr ::= PERCENT STOPWORD PERCENT */
   -5,  /* (42) text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT */
   -7,  /* (43) text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT */
   -1,  /* (44) modifier ::= MODIFIER */
   -3,  /* (45) modifierlist ::= modifier OR term */
   -3,  /* (46) modifierlist ::= modifierlist OR term */
   -3,  /* (47) expr ::= modifier COLON tag_list */
   -2,  /* (48) tag_list ::= LB param_term */
   -2,  /* (49) tag_list ::= LB STOPWORD */
   -2,  /* (50) tag_list ::= LB prefix */
   -2,  /* (51) tag_list ::= LB termlist */
   -3,  /* (52) tag_list ::= tag_list OR param_term */
   -3,  /* (53) tag_list ::= tag_list OR STOPWORD */
   -3,  /* (54) tag_list ::= tag_list OR prefix */
   -3,  /* (55) tag_list ::= tag_list OR termlist */
   -2,  /* (56) tag_list ::= tag_list RB */
   -3,  /* (57) expr ::= modifier COLON numeric_range */
   -4,  /* (58) numeric_range ::= LSQB param_any param_any RSQB */
   -3,  /* (59) expr ::= modifier COLON geo_filter */
   -6,  /* (60) geo_filter ::= LSQB param_any param_any param_any param_any RSQB */
   -5,  /* (61) query ::= expr ARROW LSQB vector_query RSQB */
   -5,  /* (62) query ::= star ARROW LSQB vector_query RSQB */
   -4,  /* (63) vector_query ::= vector_command vector_attribute_list AS param_term */
   -3,  /* (64) vector_query ::= vector_command AS param_term */
   -2,  /* (65) vector_query ::= vector_command vector_attribute_list */
   -1,  /* (66) vector_query ::= vector_command */
   -4,  /* (67) vector_command ::= TOP_K param_size modifier ATTRIBUTE */
   -2,  /* (68) vector_attribute ::= TERM param_term */
   -2,  /* (69) vector_attribute_list ::= vector_attribute_list vector_attribute */
   -1,  /* (70) vector_attribute_list ::= vector_attribute */
   -1,  /* (71) num ::= SIZE */
   -1,  /* (72) num ::= NUMBER */
   -2,  /* (73) num ::= LP num */
   -2,  /* (74) num ::= MINUS num */
   -1,  /* (75) term ::= TERM */
   -1,  /* (76) term ::= NUMBER */
   -1,  /* (77) term ::= SIZE */
   -1,  /* (78) param_term ::= TERM */
   -1,  /* (79) param_term ::= NUMBER */
   -1,  /* (80) param_term ::= SIZE */
   -1,  /* (81) param_term ::= ATTRIBUTE */
   -1,  /* (82) param_size ::= SIZE */
   -1,  /* (83) param_size ::= ATTRIBUTE */
   -1,  /* (84) param_any ::= ATTRIBUTE */
   -2,  /* (85) param_any ::= LP ATTRIBUTE */
   -1,  /* (86) param_any ::= TERM */
   -1,  /* (87) param_any ::= num */
   -1,  /* (88) star ::= STAR */
   -3,  /* (89) star ::= LP star RP */
};

static void yy_accept(yyParser*);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
**
** The yyLookahead and yyLookaheadToken parameters provide reduce actions
** access to the lookahead token (if any).  The yyLookahead will be YYNOCODE
** if the lookahead token has already been consumed.  As this procedure is
** only called from one place, optimizing compilers will in-line it, which
** means that the extra parameters have no performance impact.
*/
static YYACTIONTYPE yy_reduce(
  yyParser *yypParser,         /* The parser */
  unsigned int yyruleno,       /* Number of the rule by which to reduce */
  int yyLookahead,             /* Lookahead token, or YYNOCODE if none */
  RSQueryParser_TOKENTYPE yyLookaheadToken  /* Value of the lookahead token */
  RSQueryParser_CTX_PDECL                   /* %extra_context */
){
  int yygoto;                     /* The next state */
  YYACTIONTYPE yyact;             /* The next action */
  yyStackEntry *yymsp;            /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  RSQueryParser_ARG_FETCH
  (void)yyLookahead;
  (void)yyLookaheadToken;
  yymsp = yypParser->yytos;

  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
/********** Begin reduce actions **********************************************/
        YYMINORTYPE yylhsminor;
      case 0: /* query ::= expr */
{ 
  setup_trace(ctx);
  ctx->root = yymsp[0].minor.yy35;
}
        break;
      case 1: /* query ::= */
{
  ctx->root = NULL;
}
        break;
      case 2: /* query ::= star */
{  yy_destructor(yypParser,50,&yymsp[0].minor);
{
  setup_trace(ctx);
  ctx->root = NewWildcardNode();
}
}
        break;
      case 3: /* expr ::= expr expr */
{
    int rv = one_not_null(yymsp[-1].minor.yy35, yymsp[0].minor.yy35, (void**)&yylhsminor.yy35);
    if (rv == NODENN_BOTH_INVALID) {
        yylhsminor.yy35 = NULL;
    } else if (rv == NODENN_ONE_NULL) {
        // Nothing- `out` is already assigned
    } else {
        if (yymsp[-1].minor.yy35 && yymsp[-1].minor.yy35->type == QN_PHRASE && yymsp[-1].minor.yy35->pn.exact == 0 && 
            yymsp[-1].minor.yy35->opts.fieldMask == RS_FIELDMASK_ALL ) {
            yylhsminor.yy35 = yymsp[-1].minor.yy35;
        } else {     
            yylhsminor.yy35 = NewPhraseNode(0);
            QueryNode_AddChild(yylhsminor.yy35, yymsp[-1].minor.yy35);
        }
        QueryNode_AddChild(yylhsminor.yy35, yymsp[0].minor.yy35);
    }
}
  yymsp[-1].minor.yy35 = yylhsminor.yy35;
        break;
      case 4: /* text_expr ::= text_expr text_expr */
{
    int rv = one_not_null(yymsp[-1].minor.yy35, yymsp[0].minor.yy35, (void**)&yylhsminor.yy35);
    if (rv == NODENN_BOTH_INVALID) {
        yylhsminor.yy35 = NULL;
    } else if (rv == NODENN_ONE_NULL) {
        // Nothing- `out` is already assigned
    } else {
        if (yymsp[-1].minor.yy35 && yymsp[-1].minor.yy35->type == QN_PHRASE && yymsp[-1].minor.yy35->pn.exact == 0 &&
            yymsp[-1].minor.yy35->opts.fieldMask == RS_FIELDMASK_ALL ) {
            yylhsminor.yy35 = yymsp[-1].minor.yy35;
        } else {
            yylhsminor.yy35 = NewPhraseNode(0);
            QueryNode_AddChild(yylhsminor.yy35, yymsp[-1].minor.yy35);
        }
        QueryNode_AddChild(yylhsminor.yy35, yymsp[0].minor.yy35);
    }
}
  yymsp[-1].minor.yy35 = yylhsminor.yy35;
        break;
      case 5: /* expr ::= union */
      case 8: /* text_expr ::= text_union */ yytestcase(yyruleno==8);
      case 27: /* text_expr ::= prefix */ yytestcase(yyruleno==27);
{
    yylhsminor.yy35 = yymsp[0].minor.yy35;
}
  yymsp[0].minor.yy35 = yylhsminor.yy35;
        break;
      case 6: /* union ::= expr OR expr */
{
    int rv = one_not_null(yymsp[-2].minor.yy35, yymsp[0].minor.yy35, (void**)&yylhsminor.yy35);
    if (rv == NODENN_BOTH_INVALID) {
        yylhsminor.yy35 = NULL;
    } else if (rv == NODENN_ONE_NULL) {
        // Nothing- already assigned
    } else {
        if (yymsp[-2].minor.yy35->type == QN_UNION && yymsp[-2].minor.yy35->opts.fieldMask == RS_FIELDMASK_ALL) {
            yylhsminor.yy35 = yymsp[-2].minor.yy35;
        } else {
            yylhsminor.yy35 = NewUnionNode();
            QueryNode_AddChild(yylhsminor.yy35, yymsp[-2].minor.yy35);
            yylhsminor.yy35->opts.fieldMask |= yymsp[-2].minor.yy35->opts.fieldMask;
        }

        // Handle yymsp[0].minor.yy35
        QueryNode_AddChild(yylhsminor.yy35, yymsp[0].minor.yy35);
        yylhsminor.yy35->opts.fieldMask |= yymsp[0].minor.yy35->opts.fieldMask;
        QueryNode_SetFieldMask(yylhsminor.yy35, yylhsminor.yy35->opts.fieldMask);
    }
    
}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 7: /* union ::= union OR expr */
      case 10: /* text_union ::= text_union OR text_expr */ yytestcase(yyruleno==10);
{
    yylhsminor.yy35 = yymsp[-2].minor.yy35;
    if (yymsp[0].minor.yy35) {
        QueryNode_AddChild(yylhsminor.yy35, yymsp[0].minor.yy35);
        yylhsminor.yy35->opts.fieldMask |= yymsp[0].minor.yy35->opts.fieldMask;
        QueryNode_SetFieldMask(yymsp[0].minor.yy35, yylhsminor.yy35->opts.fieldMask);
    }
}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 9: /* text_union ::= text_expr OR text_expr */
{
    int rv = one_not_null(yymsp[-2].minor.yy35, yymsp[0].minor.yy35, (void**)&yylhsminor.yy35);
    if (rv == NODENN_BOTH_INVALID) {
        yylhsminor.yy35 = NULL;
    } else if (rv == NODENN_ONE_NULL) {
        // Nothing- already assigned
    } else {
        if (yymsp[-2].minor.yy35->type == QN_UNION && yymsp[-2].minor.yy35->opts.fieldMask == RS_FIELDMASK_ALL) {
            yylhsminor.yy35 = yymsp[-2].minor.yy35;
        } else {
            yylhsminor.yy35 = NewUnionNode();
            QueryNode_AddChild(yylhsminor.yy35, yymsp[-2].minor.yy35);
            yylhsminor.yy35->opts.fieldMask |= yymsp[-2].minor.yy35->opts.fieldMask;
        }

        // Handle yymsp[0].minor.yy35
        QueryNode_AddChild(yylhsminor.yy35, yymsp[0].minor.yy35);
        yylhsminor.yy35->opts.fieldMask |= yymsp[0].minor.yy35->opts.fieldMask;
        QueryNode_SetFieldMask(yylhsminor.yy35, yylhsminor.yy35->opts.fieldMask);
    }

}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 11: /* expr ::= text_expr */
      case 66: /* vector_query ::= vector_command */ yytestcase(yyruleno==66);
{
  yylhsminor.yy35 = yymsp[0].minor.yy35;
}
  yymsp[0].minor.yy35 = yylhsminor.yy35;
        break;
      case 12: /* expr ::= modifier COLON text_expr */
{
    if (yymsp[0].minor.yy35 == NULL) {
        yylhsminor.yy35 = NULL;
    } else {
        if (ctx->sctx->spec) {
            QueryNode_SetFieldMask(yymsp[0].minor.yy35, IndexSpec_GetFieldBit(ctx->sctx->spec, yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len));
        }
        yylhsminor.yy35 = yymsp[0].minor.yy35; 
    }
}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 13: /* expr ::= modifierlist COLON text_expr */
{
    
    if (yymsp[0].minor.yy35 == NULL) {
        yylhsminor.yy35 = NULL;
    } else {
        //yymsp[0].minor.yy35->opts.fieldMask = 0;
        t_fieldMask mask = 0; 
        if (ctx->sctx->spec) {
            for (int i = 0; i < Vector_Size(yymsp[-2].minor.yy50); i++) {
                char *p;
                Vector_Get(yymsp[-2].minor.yy50, i, &p);
                mask |= IndexSpec_GetFieldBit(ctx->sctx->spec, p, strlen(p)); 
                rm_free(p);
            }
        }
        QueryNode_SetFieldMask(yymsp[0].minor.yy35, mask);
        Vector_Free(yymsp[-2].minor.yy50);
        yylhsminor.yy35=yymsp[0].minor.yy35;
    }
}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 14: /* expr ::= LP expr RP */
      case 15: /* text_expr ::= LP text_expr RP */ yytestcase(yyruleno==15);
{
    yymsp[-2].minor.yy35 = yymsp[-1].minor.yy35;
}
        break;
      case 16: /* attribute ::= ATTRIBUTE COLON param_term */
{
  const char *value = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
  size_t value_len = yymsp[0].minor.yy0.len;
  if (yymsp[0].minor.yy0.type == QT_PARAM_TERM) {
    size_t found_value_len;
    const char *found_value = Param_DictGet(ctx->opts->params, value, &found_value_len, ctx->status);
    if (found_value) {
      rm_free((char*)value);
      value = rm_strndup(found_value, found_value_len);
      value_len = found_value_len;
    }
  }
  yylhsminor.yy55 = (QueryAttribute){ .name = yymsp[-2].minor.yy0.s, .namelen = yymsp[-2].minor.yy0.len, .value = value, .vallen = value_len };
}
  yymsp[-2].minor.yy55 = yylhsminor.yy55;
        break;
      case 17: /* attribute_list ::= attribute */
{
  yylhsminor.yy97 = array_new(QueryAttribute, 2);
  yylhsminor.yy97 = array_append(yylhsminor.yy97, yymsp[0].minor.yy55);
}
  yymsp[0].minor.yy97 = yylhsminor.yy97;
        break;
      case 18: /* attribute_list ::= attribute_list SEMICOLON attribute */
{
  yylhsminor.yy97 = array_append(yymsp[-2].minor.yy97, yymsp[0].minor.yy55);
}
  yymsp[-2].minor.yy97 = yylhsminor.yy97;
        break;
      case 19: /* attribute_list ::= attribute_list SEMICOLON */
{
    yylhsminor.yy97 = yymsp[-1].minor.yy97;
}
  yymsp[-1].minor.yy97 = yylhsminor.yy97;
        break;
      case 20: /* attribute_list ::= */
{
    yymsp[1].minor.yy97 = NULL;
}
        break;
      case 21: /* expr ::= expr ARROW LB attribute_list RB */
      case 22: /* text_expr ::= text_expr ARROW LB attribute_list RB */ yytestcase(yyruleno==22);
{

    if (yymsp[-4].minor.yy35 && yymsp[-1].minor.yy97) {
        QueryNode_ApplyAttributes(yymsp[-4].minor.yy35, yymsp[-1].minor.yy97, array_len(yymsp[-1].minor.yy97), ctx->status);
    }
    array_free_ex(yymsp[-1].minor.yy97, rm_free((char*)((QueryAttribute*)ptr )->value));
    yylhsminor.yy35 = yymsp[-4].minor.yy35;
}
  yymsp[-4].minor.yy35 = yylhsminor.yy35;
        break;
      case 23: /* text_expr ::= QUOTE termlist QUOTE */
{
  // TODO: Quoted/verbatim string in termlist should not be handled as parameters
  // Also need to add the leading '$' which was consumed by the lexer
  yymsp[-1].minor.yy35->pn.exact = 1;
  yymsp[-1].minor.yy35->opts.flags |= QueryNode_Verbatim;

  yymsp[-2].minor.yy35 = yymsp[-1].minor.yy35;
}
        break;
      case 24: /* text_expr ::= QUOTE term QUOTE */
{
  yymsp[-2].minor.yy35 = NewTokenNode(ctx, rm_strdupcase(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len), -1);
  yymsp[-2].minor.yy35->opts.flags |= QueryNode_Verbatim;
}
        break;
      case 25: /* text_expr ::= QUOTE ATTRIBUTE QUOTE */
{
  // Quoted/verbatim string should not be handled as parameters
  // Also need to add the leading '$' which was consumed by the lexer
  char *s = rm_malloc(yymsp[-1].minor.yy0.len + 1);
  *s = '$';
  memcpy(s + 1, yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
  yymsp[-2].minor.yy35 = NewTokenNode(ctx, rm_strdupcase(s, yymsp[-1].minor.yy0.len + 1), -1);
  rm_free(s);
  yymsp[-2].minor.yy35->opts.flags |= QueryNode_Verbatim;
}
        break;
      case 26: /* text_expr ::= param_term */
{
  yylhsminor.yy35 = NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0);
}
  yymsp[0].minor.yy35 = yylhsminor.yy35;
        break;
      case 28: /* text_expr ::= termlist */
{
        yylhsminor.yy35 = yymsp[0].minor.yy35;
}
  yymsp[0].minor.yy35 = yylhsminor.yy35;
        break;
      case 29: /* text_expr ::= STOPWORD */
{
    yymsp[0].minor.yy35 = NULL;
}
        break;
      case 30: /* termlist ::= param_term param_term */
{
  yylhsminor.yy35 = NewPhraseNode(0);
  QueryNode_AddChild(yylhsminor.yy35, NewTokenNode_WithParams(ctx, &yymsp[-1].minor.yy0));
  QueryNode_AddChild(yylhsminor.yy35, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
}
  yymsp[-1].minor.yy35 = yylhsminor.yy35;
        break;
      case 31: /* termlist ::= termlist param_term */
{
  yylhsminor.yy35 = yymsp[-1].minor.yy35;
  QueryNode_AddChild(yylhsminor.yy35, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
}
  yymsp[-1].minor.yy35 = yylhsminor.yy35;
        break;
      case 32: /* termlist ::= termlist STOPWORD */
      case 56: /* tag_list ::= tag_list RB */ yytestcase(yyruleno==56);
{
    yylhsminor.yy35 = yymsp[-1].minor.yy35;
}
  yymsp[-1].minor.yy35 = yylhsminor.yy35;
        break;
      case 33: /* expr ::= MINUS expr */
      case 34: /* text_expr ::= MINUS text_expr */ yytestcase(yyruleno==34);
{
    if (yymsp[0].minor.yy35) {
        yymsp[-1].minor.yy35 = NewNotNode(yymsp[0].minor.yy35);
    } else {
        yymsp[-1].minor.yy35 = NULL;
    }
}
        break;
      case 35: /* expr ::= TILDE expr */
      case 36: /* text_expr ::= TILDE text_expr */ yytestcase(yyruleno==36);
{
    if (yymsp[0].minor.yy35) {
        yymsp[-1].minor.yy35 = NewOptionalNode(yymsp[0].minor.yy35);
    } else {
        yymsp[-1].minor.yy35 = NULL;
    }
}
        break;
      case 37: /* prefix ::= PREFIX */
{
    yylhsminor.yy35 = NewPrefixNode_WithParams(ctx, &yymsp[0].minor.yy0);
}
  yymsp[0].minor.yy35 = yylhsminor.yy35;
        break;
      case 38: /* text_expr ::= PERCENT param_term PERCENT */
      case 41: /* text_expr ::= PERCENT STOPWORD PERCENT */ yytestcase(yyruleno==41);
{
  yymsp[-2].minor.yy35 = NewFuzzyNode_WithParams(ctx, &yymsp[-1].minor.yy0, 1);
}
        break;
      case 39: /* text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
      case 42: /* text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT */ yytestcase(yyruleno==42);
{
  yymsp[-4].minor.yy35 = NewFuzzyNode_WithParams(ctx, &yymsp[-2].minor.yy0, 2);
}
        break;
      case 40: /* text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
      case 43: /* text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT */ yytestcase(yyruleno==43);
{
  yymsp[-6].minor.yy35 = NewFuzzyNode_WithParams(ctx, &yymsp[-3].minor.yy0, 3);
}
        break;
      case 44: /* modifier ::= MODIFIER */
{
    yymsp[0].minor.yy0.len = unescapen((char*)yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    yylhsminor.yy0 = yymsp[0].minor.yy0;
 }
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 45: /* modifierlist ::= modifier OR term */
{
    yylhsminor.yy50 = NewVector(char *, 2);
    char *s = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    Vector_Push(yylhsminor.yy50, s);
    s = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    Vector_Push(yylhsminor.yy50, s);
}
  yymsp[-2].minor.yy50 = yylhsminor.yy50;
        break;
      case 46: /* modifierlist ::= modifierlist OR term */
{
    char *s = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    Vector_Push(yymsp[-2].minor.yy50, s);
    yylhsminor.yy50 = yymsp[-2].minor.yy50;
}
  yymsp[-2].minor.yy50 = yylhsminor.yy50;
        break;
      case 47: /* expr ::= modifier COLON tag_list */
{
    if (!yymsp[0].minor.yy35) {
        yylhsminor.yy35= NULL;
    } else {
      // Tag field names must be case sensitive, we can't do rm_strdupcase
        char *s = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
        size_t slen = unescapen((char*)s, yymsp[-2].minor.yy0.len);

        yylhsminor.yy35 = NewTagNode(s, slen);
        QueryNode_AddChildren(yylhsminor.yy35, yymsp[0].minor.yy35->children, QueryNode_NumChildren(yymsp[0].minor.yy35));
        
        // Set the children count on yymsp[0].minor.yy35 to 0 so they won't get recursively free'd
        QueryNode_ClearChildren(yymsp[0].minor.yy35, 0);
        QueryNode_Free(yymsp[0].minor.yy35);
    }
}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 48: /* tag_list ::= LB param_term */
{
  yymsp[-1].minor.yy35 = NewPhraseNode(0);
  if (yymsp[0].minor.yy0.type == QT_TERM)
    yymsp[0].minor.yy0.type = QT_TERM_CASE;
  else if (yymsp[0].minor.yy0.type == QT_PARAM_TERM)
    yymsp[0].minor.yy0.type = QT_PARAM_TERM_CASE;
  QueryNode_AddChild(yymsp[-1].minor.yy35, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
}
        break;
      case 49: /* tag_list ::= LB STOPWORD */
{
    yymsp[-1].minor.yy35 = NewPhraseNode(0);
    QueryNode_AddChild(yymsp[-1].minor.yy35, NewTokenNode(ctx, rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len), -1));
}
        break;
      case 50: /* tag_list ::= LB prefix */
      case 51: /* tag_list ::= LB termlist */ yytestcase(yyruleno==51);
{
    yymsp[-1].minor.yy35 = NewPhraseNode(0);
    QueryNode_AddChild(yymsp[-1].minor.yy35, yymsp[0].minor.yy35);
}
        break;
      case 52: /* tag_list ::= tag_list OR param_term */
{
  if (yymsp[0].minor.yy0.type == QT_TERM)
    yymsp[0].minor.yy0.type = QT_TERM_CASE;
  else if (yymsp[0].minor.yy0.type == QT_PARAM_TERM)
    yymsp[0].minor.yy0.type = QT_PARAM_TERM_CASE;
  QueryNode_AddChild(yymsp[-2].minor.yy35, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
  yylhsminor.yy35 = yymsp[-2].minor.yy35;
}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 53: /* tag_list ::= tag_list OR STOPWORD */
{
    QueryNode_AddChild(yymsp[-2].minor.yy35, NewTokenNode(ctx, rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len), -1));
    yylhsminor.yy35 = yymsp[-2].minor.yy35;
}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 54: /* tag_list ::= tag_list OR prefix */
      case 55: /* tag_list ::= tag_list OR termlist */ yytestcase(yyruleno==55);
{
    QueryNode_AddChild(yymsp[-2].minor.yy35, yymsp[0].minor.yy35);
    yylhsminor.yy35 = yymsp[-2].minor.yy35;
}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 57: /* expr ::= modifier COLON numeric_range */
{
  if (yymsp[0].minor.yy78) {
    // we keep the capitalization as is
    yymsp[0].minor.yy78->nf->fieldName = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    yylhsminor.yy35 = NewNumericNode(yymsp[0].minor.yy78);
  } else {
    yylhsminor.yy35 = NewQueryNode(QN_NULL);
  }
}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 58: /* numeric_range ::= LSQB param_any param_any RSQB */
{
  // Update token type to be more specific if possible
  // and detect syntax errors
  QueryToken *badToken = NULL;
  if (yymsp[-2].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-2].minor.yy0.type = QT_PARAM_NUMERIC_MIN_RANGE;
  else if (yymsp[-2].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-2].minor.yy0;
  if (yymsp[-1].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-1].minor.yy0.type = QT_PARAM_NUMERIC_MAX_RANGE;
  else if (!badToken && yymsp[-1].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-1].minor.yy0;

  if (!badToken) {
    yymsp[-3].minor.yy78 = NewNumericFilterQueryParam_WithParams(ctx, &yymsp[-2].minor.yy0, &yymsp[-1].minor.yy0, yymsp[-2].minor.yy0.inclusive, yymsp[-1].minor.yy0.inclusive);
  } else {
    reportSyntaxError(ctx->status, badToken, "Expecting numeric or parameter");
    yymsp[-3].minor.yy78 = NULL;
  }
}
        break;
      case 59: /* expr ::= modifier COLON geo_filter */
{
  if (yymsp[0].minor.yy78) {
    // we keep the capitalization as is
    yymsp[0].minor.yy78->gf->property = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    yylhsminor.yy35 = NewGeofilterNode(yymsp[0].minor.yy78);
  } else {
    yylhsminor.yy35 = NewQueryNode(QN_NULL);
  }
}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 60: /* geo_filter ::= LSQB param_any param_any param_any param_any RSQB */
{
  // Update token type to be more specific if possible
  // and detect syntax errors
  QueryToken *badToken = NULL;

  if (yymsp[-4].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-4].minor.yy0.type = QT_PARAM_GEO_COORD;
  else if (yymsp[-4].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-4].minor.yy0;
  if (yymsp[-3].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-3].minor.yy0.type = QT_PARAM_GEO_COORD;
  else if (!badToken && yymsp[-3].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-3].minor.yy0;
  if (yymsp[-2].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-2].minor.yy0.type = QT_PARAM_NUMERIC;
  else if (!badToken && yymsp[-2].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-2].minor.yy0;
  if (yymsp[-1].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-1].minor.yy0.type = QT_PARAM_GEO_UNIT;
  else if (!badToken && yymsp[-1].minor.yy0.type != QT_TERM)
    badToken = &yymsp[-1].minor.yy0;

  if (!badToken) {
    yymsp[-5].minor.yy78 = NewGeoFilterQueryParam_WithParams(ctx, &yymsp[-4].minor.yy0, &yymsp[-3].minor.yy0, &yymsp[-2].minor.yy0, &yymsp[-1].minor.yy0);
  } else {
    reportSyntaxError(ctx->status, badToken, "Syntax error");
    yymsp[-5].minor.yy78 = NULL;
  }
}
        break;
      case 61: /* query ::= expr ARROW LSQB vector_query RSQB */
{ // main parse, hybrid query as entire query case.
  setup_trace(ctx);
  switch (yymsp[-1].minor.yy35->vn.vq->type) {
    case VECSIM_QT_TOPK:
      yymsp[-1].minor.yy35->vn.vq->topk.order = BY_SCORE;
      break;
  }
  ctx->root = yymsp[-1].minor.yy35;
  QueryNode_AddChild(yymsp[-1].minor.yy35, yymsp[-4].minor.yy35);
}
        break;
      case 62: /* query ::= star ARROW LSQB vector_query RSQB */
{  yy_destructor(yypParser,50,&yymsp[-4].minor);
{ // main parse, simple vecsim search as entire query case.
  setup_trace(ctx);
  switch (yymsp[-1].minor.yy35->vn.vq->type) {
    case VECSIM_QT_TOPK:
      yymsp[-1].minor.yy35->vn.vq->topk.order = BY_SCORE;
      break;
  }
  ctx->root = yymsp[-1].minor.yy35;
}
}
        break;
      case 63: /* vector_query ::= vector_command vector_attribute_list AS param_term */
{
  if (yymsp[-3].minor.yy35->vn.vq->scoreField) {
    rm_free(yymsp[-3].minor.yy35->vn.vq->scoreField);
    yymsp[-3].minor.yy35->vn.vq->scoreField = NULL;
  }
  yymsp[-3].minor.yy35->params = array_grow(yymsp[-3].minor.yy35->params, 1);
  memset(&array_tail(yymsp[-3].minor.yy35->params), 0, sizeof(*yymsp[-3].minor.yy35->params));
  QueryNode_SetParam(ctx, &(array_tail(yymsp[-3].minor.yy35->params)), &(yymsp[-3].minor.yy35->vn.vq->scoreField), NULL, &yymsp[0].minor.yy0);
  yymsp[-3].minor.yy35->vn.vq->params = yymsp[-2].minor.yy74;
  yylhsminor.yy35 = yymsp[-3].minor.yy35;
}
  yymsp[-3].minor.yy35 = yylhsminor.yy35;
        break;
      case 64: /* vector_query ::= vector_command AS param_term */
{
  if (yymsp[-2].minor.yy35->vn.vq->scoreField) {
    rm_free(yymsp[-2].minor.yy35->vn.vq->scoreField);
    yymsp[-2].minor.yy35->vn.vq->scoreField = NULL;
  }
  yymsp[-2].minor.yy35->params = array_grow(yymsp[-2].minor.yy35->params, 1);
  memset(&array_tail(yymsp[-2].minor.yy35->params), 0, sizeof(*yymsp[-2].minor.yy35->params));
  QueryNode_SetParam(ctx, &(array_tail(yymsp[-2].minor.yy35->params)), &(yymsp[-2].minor.yy35->vn.vq->scoreField), NULL, &yymsp[0].minor.yy0);
  yylhsminor.yy35 = yymsp[-2].minor.yy35;
}
  yymsp[-2].minor.yy35 = yylhsminor.yy35;
        break;
      case 65: /* vector_query ::= vector_command vector_attribute_list */
{
  yymsp[-1].minor.yy35->vn.vq->params = yymsp[0].minor.yy74;
  yylhsminor.yy35 = yymsp[-1].minor.yy35;
}
  yymsp[-1].minor.yy35 = yylhsminor.yy35;
        break;
      case 67: /* vector_command ::= TOP_K param_size modifier ATTRIBUTE */
{
  yymsp[0].minor.yy0.type = QT_PARAM_VEC;
  yymsp[-3].minor.yy35 = NewVectorNode_WithParams(ctx, VECSIM_QT_TOPK, &yymsp[-2].minor.yy0, &yymsp[0].minor.yy0);
  yymsp[-3].minor.yy35->vn.vq->property = rm_strndup(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
  RedisModule_Assert(-1 != (rm_asprintf(&yymsp[-3].minor.yy35->vn.vq->scoreField, "__%.*s_score", yymsp[-1].minor.yy0.len, yymsp[-1].minor.yy0.s)));
}
        break;
      case 68: /* vector_attribute ::= TERM param_term */
{
  const char *value = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
  const char *name = rm_strndup(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
  yylhsminor.yy61.param = (VecSimRawParam){ .name = name, .nameLen = yymsp[-1].minor.yy0.len, .value = value, .valLen = yymsp[0].minor.yy0.len };
  if (yymsp[0].minor.yy0.type == QT_PARAM_TERM) {
    yylhsminor.yy61.needResolve = true;
  }
  else { // if yymsp[0].minor.yy0.type == QT_TERM
    yylhsminor.yy61.needResolve = false;
  }
}
  yymsp[-1].minor.yy61 = yylhsminor.yy61;
        break;
      case 69: /* vector_attribute_list ::= vector_attribute_list vector_attribute */
{
  yylhsminor.yy74.params = array_append(yymsp[-1].minor.yy74.params, yymsp[0].minor.yy61.param);
  yylhsminor.yy74.needResolve = array_append(yymsp[-1].minor.yy74.needResolve, yymsp[0].minor.yy61.needResolve);
}
  yymsp[-1].minor.yy74 = yylhsminor.yy74;
        break;
      case 70: /* vector_attribute_list ::= vector_attribute */
{
  yylhsminor.yy74.params = array_new(VecSimRawParam, 1);
  yylhsminor.yy74.needResolve = array_new(bool, 1);
  yylhsminor.yy74.params = array_append(yylhsminor.yy74.params, yymsp[0].minor.yy61.param);
  yylhsminor.yy74.needResolve = array_append(yylhsminor.yy74.needResolve, yymsp[0].minor.yy61.needResolve);
}
  yymsp[0].minor.yy74 = yylhsminor.yy74;
        break;
      case 71: /* num ::= SIZE */
      case 72: /* num ::= NUMBER */ yytestcase(yyruleno==72);
{
    yylhsminor.yy111.num = yymsp[0].minor.yy0.numval;
    yylhsminor.yy111.inclusive = 1;
}
  yymsp[0].minor.yy111 = yylhsminor.yy111;
        break;
      case 73: /* num ::= LP num */
{
    yymsp[-1].minor.yy111=yymsp[0].minor.yy111;
    yymsp[-1].minor.yy111.inclusive = 0;
}
        break;
      case 74: /* num ::= MINUS num */
{
    yymsp[0].minor.yy111.num = -yymsp[0].minor.yy111.num;
    yymsp[-1].minor.yy111 = yymsp[0].minor.yy111;
}
        break;
      case 75: /* term ::= TERM */
      case 76: /* term ::= NUMBER */ yytestcase(yyruleno==76);
{
    yylhsminor.yy0 = yymsp[0].minor.yy0; 
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 77: /* term ::= SIZE */
{
    yylhsminor.yy0 = yymsp[0].minor.yy0;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 78: /* param_term ::= TERM */
      case 86: /* param_any ::= TERM */ yytestcase(yyruleno==86);
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_TERM;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 79: /* param_term ::= NUMBER */
      case 80: /* param_term ::= SIZE */ yytestcase(yyruleno==80);
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  // Number is treated as a term here
  yylhsminor.yy0.type = QT_TERM;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 81: /* param_term ::= ATTRIBUTE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_PARAM_TERM;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 82: /* param_size ::= SIZE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_SIZE;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 83: /* param_size ::= ATTRIBUTE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_PARAM_SIZE;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 84: /* param_any ::= ATTRIBUTE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_PARAM_ANY;
  yylhsminor.yy0.inclusive = 1;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 85: /* param_any ::= LP ATTRIBUTE */
{
  yymsp[-1].minor.yy0 = yymsp[0].minor.yy0;
  yymsp[-1].minor.yy0.type = QT_PARAM_ANY;
  yymsp[-1].minor.yy0.inclusive = 0; // Could be relevant if type is refined
}
        break;
      case 87: /* param_any ::= num */
{
  yylhsminor.yy0.numval = yymsp[0].minor.yy111.num;
  yylhsminor.yy0.inclusive = yymsp[0].minor.yy111.inclusive;
  yylhsminor.yy0.type = QT_NUMERIC;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 89: /* star ::= LP star RP */
{
}
  yy_destructor(yypParser,50,&yymsp[-1].minor);
        break;
      default:
      /* (88) star ::= STAR */ yytestcase(yyruleno==88);
        break;
/********** End reduce actions ************************************************/
  };
  assert( yyruleno<sizeof(yyRuleInfoLhs)/sizeof(yyRuleInfoLhs[0]) );
  yygoto = yyRuleInfoLhs[yyruleno];
  yysize = yyRuleInfoNRhs[yyruleno];
  yyact = yy_find_reduce_action(yymsp[yysize].stateno,(YYCODETYPE)yygoto);

  /* There are no SHIFTREDUCE actions on nonterminals because the table
  ** generator has simplified them to pure REDUCE actions. */
  assert( !(yyact>YY_MAX_SHIFT && yyact<=YY_MAX_SHIFTREDUCE) );

  /* It is not possible for a REDUCE to be followed by an error */
  assert( yyact!=YY_ERROR_ACTION );

  yymsp += yysize+1;
  yypParser->yytos = yymsp;
  yymsp->stateno = (YYACTIONTYPE)yyact;
  yymsp->major = (YYCODETYPE)yygoto;
  yyTraceShift(yypParser, yyact, "... then shift");
  return yyact;
}

/*
** The following code executes when the parse fails
*/
#ifndef YYNOERRORRECOVERY
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
){
  RSQueryParser_ARG_FETCH
  RSQueryParser_CTX_FETCH
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yytos>yypParser->yystack ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
/************ Begin %parse_failure code ***************************************/
/************ End %parse_failure code *****************************************/
  RSQueryParser_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_CTX_STORE
}
#endif /* YYNOERRORRECOVERY */

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  RSQueryParser_TOKENTYPE yyminor         /* The minor type of the error token */
){
  RSQueryParser_ARG_FETCH
  RSQueryParser_CTX_FETCH
#define TOKEN yyminor
/************ Begin %syntax_error code ****************************************/
  
    QueryError_SetErrorFmt(ctx->status, QUERY_ESYNTAX,
        "Syntax error at offset %d near %.*s",
        TOKEN.pos, TOKEN.len, TOKEN.s);
/************ End %syntax_error code ******************************************/
  RSQueryParser_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_CTX_STORE
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
){
  RSQueryParser_ARG_FETCH
  RSQueryParser_CTX_FETCH
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
#ifndef YYNOERRORRECOVERY
  yypParser->yyerrcnt = -1;
#endif
  assert( yypParser->yytos==yypParser->yystack );
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
/*********** Begin %parse_accept code *****************************************/
/*********** End %parse_accept code *******************************************/
  RSQueryParser_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_CTX_STORE
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "RSQueryParser_Alloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void RSQueryParser_(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  RSQueryParser_TOKENTYPE yyminor       /* The value for the token */
  RSQueryParser_ARG_PDECL               /* Optional %extra_argument parameter */
){
  YYMINORTYPE yyminorunion;
  YYACTIONTYPE yyact;   /* The parser action. */
#if !defined(YYERRORSYMBOL) && !defined(YYNOERRORRECOVERY)
  int yyendofinput;     /* True if we are at the end of input */
#endif
#ifdef YYERRORSYMBOL
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
#endif
  yyParser *yypParser = (yyParser*)yyp;  /* The parser */
  RSQueryParser_CTX_FETCH
  RSQueryParser_ARG_STORE

  assert( yypParser->yytos!=0 );
#if !defined(YYERRORSYMBOL) && !defined(YYNOERRORRECOVERY)
  yyendofinput = (yymajor==0);
#endif

  yyact = yypParser->yytos->stateno;
#ifndef NDEBUG
  if( yyTraceFILE ){
    if( yyact < YY_MIN_REDUCE ){
      fprintf(yyTraceFILE,"%sInput '%s' in state %d\n",
              yyTracePrompt,yyTokenName[yymajor],yyact);
    }else{
      fprintf(yyTraceFILE,"%sInput '%s' with pending reduce %d\n",
              yyTracePrompt,yyTokenName[yymajor],yyact-YY_MIN_REDUCE);
    }
  }
#endif

  while(1){ /* Exit by "break" */
    assert( yypParser->yytos>=yypParser->yystack );
    assert( yyact==yypParser->yytos->stateno );
    yyact = yy_find_shift_action((YYCODETYPE)yymajor,yyact);
    if( yyact >= YY_MIN_REDUCE ){
      unsigned int yyruleno = yyact - YY_MIN_REDUCE; /* Reduce by this rule */
#ifndef NDEBUG
      assert( yyruleno<(int)(sizeof(yyRuleName)/sizeof(yyRuleName[0])) );
      if( yyTraceFILE ){
        int yysize = yyRuleInfoNRhs[yyruleno];
        if( yysize ){
          fprintf(yyTraceFILE, "%sReduce %d [%s]%s, pop back to state %d.\n",
            yyTracePrompt,
            yyruleno, yyRuleName[yyruleno],
            yyruleno<YYNRULE_WITH_ACTION ? "" : " without external action",
            yypParser->yytos[yysize].stateno);
        }else{
          fprintf(yyTraceFILE, "%sReduce %d [%s]%s.\n",
            yyTracePrompt, yyruleno, yyRuleName[yyruleno],
            yyruleno<YYNRULE_WITH_ACTION ? "" : " without external action");
        }
      }
#endif /* NDEBUG */

      /* Check that the stack is large enough to grow by a single entry
      ** if the RHS of the rule is empty.  This ensures that there is room
      ** enough on the stack to push the LHS value */
      if( yyRuleInfoNRhs[yyruleno]==0 ){
#ifdef YYTRACKMAXSTACKDEPTH
        if( (int)(yypParser->yytos - yypParser->yystack)>yypParser->yyhwm ){
          yypParser->yyhwm++;
          assert( yypParser->yyhwm ==
                  (int)(yypParser->yytos - yypParser->yystack));
        }
#endif
#if YYSTACKDEPTH>0 
        if( yypParser->yytos>=yypParser->yystackEnd ){
          yyStackOverflow(yypParser);
          break;
        }
#else
        if( yypParser->yytos>=&yypParser->yystack[yypParser->yystksz-1] ){
          if( yyGrowStack(yypParser) ){
            yyStackOverflow(yypParser);
            break;
          }
        }
#endif
      }
      yyact = yy_reduce(yypParser,yyruleno,yymajor,yyminor RSQueryParser_CTX_PARAM);
    }else if( yyact <= YY_MAX_SHIFTREDUCE ){
      yy_shift(yypParser,yyact,(YYCODETYPE)yymajor,yyminor);
#ifndef YYNOERRORRECOVERY
      yypParser->yyerrcnt--;
#endif
      break;
    }else if( yyact==YY_ACCEPT_ACTION ){
      yypParser->yytos--;
      yy_accept(yypParser);
      return;
    }else{
      assert( yyact == YY_ERROR_ACTION );
      yyminorunion.yy0 = yyminor;
#ifdef YYERRORSYMBOL
      int yymx;
#endif
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->yyerrcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminor);
      }
      yymx = yypParser->yytos->major;
      if( yymx==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yypParser, (YYCODETYPE)yymajor, &yyminorunion);
        yymajor = YYNOCODE;
      }else{
        while( yypParser->yytos > yypParser->yystack ){
          yyact = yy_find_reduce_action(yypParser->yytos->stateno,
                                        YYERRORSYMBOL);
          if( yyact<=YY_MAX_SHIFTREDUCE ) break;
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->yytos <= yypParser->yystack || yymajor==0 ){
          yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
          yy_parse_failed(yypParser);
#ifndef YYNOERRORRECOVERY
          yypParser->yyerrcnt = -1;
#endif
          yymajor = YYNOCODE;
        }else if( yymx!=YYERRORSYMBOL ){
          yy_shift(yypParser,yyact,YYERRORSYMBOL,yyminor);
        }
      }
      yypParser->yyerrcnt = 3;
      yyerrorhit = 1;
      if( yymajor==YYNOCODE ) break;
      yyact = yypParser->yytos->stateno;
#elif defined(YYNOERRORRECOVERY)
      /* If the YYNOERRORRECOVERY macro is defined, then do not attempt to
      ** do any kind of error recovery.  Instead, simply invoke the syntax
      ** error routine and continue going as if nothing had happened.
      **
      ** Applications can set this macro (for example inside %include) if
      ** they intend to abandon the parse upon the first syntax error seen.
      */
      yy_syntax_error(yypParser,yymajor, yyminor);
      yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
      break;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->yyerrcnt<=0 ){
        yy_syntax_error(yypParser,yymajor, yyminor);
      }
      yypParser->yyerrcnt = 3;
      yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser);
#ifndef YYNOERRORRECOVERY
        yypParser->yyerrcnt = -1;
#endif
      }
      break;
#endif
    }
  }
#ifndef NDEBUG
  if( yyTraceFILE ){
    yyStackEntry *i;
    char cDiv = '[';
    fprintf(yyTraceFILE,"%sReturn. Stack=",yyTracePrompt);
    for(i=&yypParser->yystack[1]; i<=yypParser->yytos; i++){
      fprintf(yyTraceFILE,"%c%s", cDiv, yyTokenName[i->major]);
      cDiv = ' ';
    }
    fprintf(yyTraceFILE,"]\n");
  }
#endif
  return;
}

/*
** Return the fallback token corresponding to canonical token iToken, or
** 0 if iToken has no fallback.
*/
int RSQueryParser_Fallback(int iToken){
#ifdef YYFALLBACK
  assert( iToken<(int)(sizeof(yyFallback)/sizeof(yyFallback[0])) );
  return yyFallback[iToken];
#else
  (void)iToken;
  return 0;
#endif
}
